function rs = cns_istype(m, ns, theType)

% CNS_ISTYPE
%    Click <a href="matlab: cns_help('cns_istype')">here</a> for help.

%***********************************************************************************************************************

% Copyright (C) 2010 by Jim Mutch (www.jimmutch.com).
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public
% License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
% warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License along with this program.  If not, see
% <http://www.gnu.org/licenses/>.

%***********************************************************************************************************************

if cns_isstruct(m)

    package = m.package;

    types = cell(size(ns));
    for i = 1 : numel(ns)
        n = ns(i);
        if n > 0
            types{i} = m.layers{n}.type;
        elseif n < 0
            types{i} = cns_grouptype(m, -n);
        else
            error('invalid layer or group number');
        end
    end

elseif ischar(m)

    package = m;

    types = ns;
    if ischar(types), types = {types}; end

else

    error('invalid model or package name');

end

rs = false(size(types));

for i = 1 : numel(types)

    cname = [package '_' types{i}];

    if isempty(which(cname)), error('"%s.m" not found', cname); end

    if strcmp(types{i}, theType)
        rs(i) = true;
    else
        rs(i) = ismember([package '_' theType], superclasses(cname));
    end
    
end

return;