@echo off

rem 1 = mex script filepath
rem 2 = mex include path
rem 3 = script path (containing this file)
rem 4 = setup script filepath
rem 5 = input filepath
rem 6 = option
rem 7 = intermediate filepath
rem 8 = output filepath

call %4

if not "%CUDA%"=="1" exit 0

if not exist %5 (
    echo can't find %5
    exit 1
)

%SETUP_COMPILER%

if "%6"=="compile" (
    nvcc -cuda -I %2 %NVCC_OPTIONS% -use_fast_math -o %7 %5
) else if "%6"=="preprocess" (
    nvcc -E -I %2 %NVCC_OPTIONS% -use_fast_math -o %7 %5
) else if "%6"=="info" (
    nvcc -cubin -I %2 %NVCC_OPTIONS% -use_fast_math -o %7 %5
)

if exist %7 (
    echo CUDA preprocessing successful
) else (
    echo CUDA preprocessing [nvcc] failed
    exit 1
)

if "%6"=="compile" (
    call %1 -output %8 %7 %CUDA_LINK_LIB%
) else (
    exit 0
)

if exist %8 (
    echo CUDA compilation successful
    exit 0
) else (
    echo CUDA compilation [mex] failed
    exit 1
)
